import { LastFM } from './base';
import { LastFMParam, LastFMApiRequest, LastFMRequestParams, LastFMUnknownFunction } from './api-request';
export interface LastFMAlbumParams {
    readonly album: string;
    readonly artist: string;
}
export interface LastFMAlbumOptionalParams {
    readonly mbid?: string;
    readonly autocorrect?: 0 | 1;
}
export interface LastFMAlbumAddTagsParams extends LastFMRequestParams<LastFMParam>, LastFMAlbumParams {
    readonly tags: string | string[];
}
export interface LastFMAlbumGetInfoParams extends LastFMRequestParams<0 | 1 | void>, LastFMAlbumParams, LastFMAlbumOptionalParams {
    readonly lang?: string;
    readonly username?: string;
}
export interface LastFMAlbumGetTagsParams extends LastFMRequestParams<0 | 1 | void>, LastFMAlbumParams, LastFMAlbumOptionalParams {
    readonly user?: string;
}
export interface LastFMAlbumGetTopTagsParams extends LastFMRequestParams<0 | 1 | void>, LastFMAlbumParams, LastFMAlbumOptionalParams {
}
export interface LastFMAlbumRemoveLastFMTagParams extends LastFMRequestParams<LastFMParam>, LastFMAlbumParams {
    readonly tag: string;
}
export interface LastFMAlbumSearchParams extends LastFMRequestParams<number | void> {
    readonly page?: number;
    readonly album: string;
    readonly limit?: number;
}
export declare class LastFMAlbum extends LastFM {
    constructor(apiKey: string, secret?: string, sessionKey?: string);
    addTags(params: LastFMAlbumAddTagsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getInfo(params: LastFMAlbumGetInfoParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTags(params: LastFMAlbumGetTagsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopTags(params: LastFMAlbumGetTopTagsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    removeTag(params: LastFMAlbumRemoveLastFMTagParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    search(params: LastFMAlbumSearchParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
}
