import { LastFM } from './base';
import { LastFMParam, LastFMApiRequest, LastFMRequestParams, LastFMUnknownFunction } from './api-request';
export interface LastFMArtistParams extends LastFMRequestParams<LastFMParam> {
    readonly artist: string;
}
export interface LastFMArtistAddTagsParams extends LastFMRequestParams<LastFMParam>, LastFMArtistParams {
    readonly tags: string | string[];
}
export interface LastFMArtistGetInfoParams extends LastFMRequestParams<0 | 1 | void> {
    readonly lang?: string;
    readonly mbid?: string;
    readonly artist: string;
    readonly username?: string;
    readonly autocorrect?: 0 | 1;
}
export interface LastFMArtistGetSimilarParams extends LastFMRequestParams<0 | 1 | void | number> {
    readonly mbid?: string;
    readonly limit?: number;
    readonly artist: string;
    readonly autocorrect?: 0 | 1;
}
export interface LastFMArtistGetTagsParams extends LastFMRequestParams<0 | 1 | void> {
    readonly mbid?: string;
    readonly user?: string;
    readonly artist: string;
    readonly autocorrect?: 0 | 1;
}
export interface LastFMArtistGetTopAlbumsParams extends LastFMRequestParams<0 | 1 | void | number> {
    readonly mbid?: string;
    readonly page?: number;
    readonly limit?: number;
    readonly artist: string;
    readonly autocorrect?: 0 | 1;
}
export interface LastFMArtistGetTopTagsParams extends LastFMRequestParams<0 | 1 | void> {
    readonly mbid?: string;
    readonly artist: string;
    readonly autocorrect?: 0 | 1;
}
export interface LastFMArtistGetTopTracksParams extends LastFMRequestParams<0 | 1 | void | number> {
    readonly mbid?: string;
    readonly page?: number;
    readonly limit?: number;
    readonly artist: string;
    readonly autocorrect?: 0 | 1;
}
export interface LastFMArtistRemoveLastFMTagParams extends LastFMRequestParams<LastFMParam> {
    readonly tag: string;
    readonly artist: string;
}
export interface LastFMArtistSearchParams extends LastFMRequestParams<number | void> {
    readonly page?: number;
    readonly limit?: number;
    readonly artist: string;
}
export declare class LastFMArtist extends LastFM {
    constructor(apiKey: string, secret?: string, sessionKey?: string);
    addTags(params: LastFMArtistAddTagsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getCorrection(params: LastFMArtistParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getInfo(params: LastFMArtistGetInfoParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getSimilar(params: LastFMArtistGetSimilarParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTags(params: LastFMArtistGetTagsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopAlbums(params: LastFMArtistGetTopAlbumsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopTags(params: LastFMArtistGetTopTagsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopTracks(params: LastFMArtistGetTopTracksParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    removeTag(params: LastFMArtistRemoveLastFMTagParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    search(params: LastFMArtistSearchParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
}
