import { LastFM } from './base';
import { LastFMParam, LastFMApiRequest, LastFMRequestParams, LastFMUnknownFunction } from './api-request';
export interface LastFMAuthGetMobileSessionParams extends LastFMRequestParams<LastFMParam> {
    readonly username: string;
    readonly password: string;
}
export interface LastFMAuthGetSessionParams extends LastFMRequestParams<LastFMParam> {
    readonly token: string;
}
export declare class LastFMAuth extends LastFM {
    constructor(apiKey: string, secret?: string, sessionKey?: string);
    getMobileSession(params: LastFMAuthGetMobileSessionParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getSession(params: LastFMAuthGetSessionParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getToken(callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
}
