import { LastFM } from './base';
import { LastFMApiRequest, LastFMRequestParams, LastFMUnknownFunction } from './api-request';
export interface LastFMGeoGetTopArtistsParams extends LastFMRequestParams<number | void> {
    readonly page?: number;
    readonly limit?: number;
    readonly country: string;
}
export interface LastFMGeoGetTopTracksParams extends LastFMGeoGetTopArtistsParams {
    readonly location?: string;
}
export declare class LastFMGeo extends LastFM {
    constructor(apiKey: string, secret?: string, sessionKey?: string);
    getTopArtists(params: LastFMGeoGetTopArtistsParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopTracks(params: LastFMGeoGetTopTracksParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
}
