import { LastFM } from './base';
import { LastFMApiRequest, LastFMRequestParams, LastFMUnknownFunction } from './api-request';
export interface LastFMTagParams extends LastFMRequestParams<number | void> {
    readonly tag: string;
}
export interface LastFMTagOptionalParams {
    readonly page?: number;
    readonly limit?: number;
}
export interface LastFMTagGetInfoParams extends LastFMRequestParams<number | void>, LastFMTagParams {
    readonly lang?: string;
}
export interface LastFMTagGetTop extends LastFMRequestParams<number | void>, LastFMTagParams, LastFMTagOptionalParams {
}
export declare class LastFMTag extends LastFM {
    constructor(apiKey: string, secret?: string, sessionKey?: string);
    getInfo(params: LastFMTagGetInfoParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getSimilar(params: LastFMTagParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopAlbums(params: LastFMTagGetTop, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopArtists(params: LastFMTagGetTop, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopTags(callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getTopTracks(params: LastFMTagGetTop, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
    getWeeklyChartList(params: LastFMTagParams, callback: LastFMUnknownFunction): Promise<LastFMApiRequest> | void;
}
